#! /usr/bin/lua
-- vim:sw=4:sts=4
-- Simple calculator demo

require "gtk2"

CALC = {}

function CALC:btn_number(i, btn)
    local entry = self.entry
    local s = entry:get_text()
    s = s .. i
    entry:set_text(s)
end

-- so simpleminded...
function CALC:calculate()
    local val = 0

    while table.getn(self.stack) > 2 do
	local val1 = self.stack[1]
	local op = self.stack[2]
	local val2 = self.stack[3]
	if op == '+' then
	    val = val1 + val2
	elseif op == '-' then
	    val = val1 - val2
	end
	self.stack[1] = val
	table.remove(self.stack, 2)
	table.remove(self.stack, 2)
    end
    self.entry:set_text(val)
end

function CALC:btn_operation(op, btn)
    table.insert(self.stack, self.entry:get_text())
    if op == '=' then
	CALC.calculate(self)
    else
	table.insert(self.stack, op)
	self.entry:set_text("")
    end
end

function Calculator()

    local c = { stack={} }
    setmetatable(c, CALC)

    c.win = gtk.window_new(0)
    c.win:connect('destroy', gtk.main_quit)
    c.win:set_title('Calculator')
    local vbox = gtk.vbox_new(false, 0)
    c.win:add(vbox)

    -- number display
    c.entry = gtk.entry_new()
    c.entry:set_alignment(0.9)
    vbox:pack_start_defaults(c.entry)

    -- buttons
    local hbox
    for i=1, 9 do
	if math.mod(i, 3) == 1 then
	    hbox = gtk.hbox_new(false, 0)
	    vbox:pack_start_defaults(hbox)
	end
	local btn = gtk.button_new_with_label(i)
	btn:connect('clicked', CALC.btn_number, c, i)
	hbox:pack_start_defaults(btn)
    end

    -- operators
    hbox = gtk.hbox_new(false, 0)
    vbox:pack_start_defaults(hbox)
    for k, op in {'+', '-', '='} do
	btn = gtk.button_new_with_label(op)
	btn:connect('clicked', CALC.btn_operation, c, op)
	hbox:pack_start_defaults(btn)
    end

    c.win:show_all()
    return c
end


gtk.init(nil, nil)
local calc = Calculator()
gtk.main()


