/**
 * Read a binary file and generate a C program on stdout that, when compiled,
 * contains a string with exactly the input data.
 * Copyright (C) 2005 Wolfgang Oertl
 */

#include <stdio.h>
#include <malloc.h>

/* how many characters per line?  Note that non-printable characters are output
 * as 4 bytes: \nnn */
#define PERLINE 40

FILE *ofile;
char *prefix = "override";

/* get an item (part of hash bucket) out the door */
void store(int cnt, unsigned char *data)
{
	unsigned char c, buf[500], *p = buf;

	// curr_ofs += cnt;

	// if (!real)
	// 	return;

	while (cnt--) {
		c = *data++;
		if (c == '"' || c == '\\')
			*p++ = '\\';
		/* avoid trigraphs by storing ( as octal */
		if (c >= ' ' && c < 127 && c != '(') {
			*p++ = c;
		} else {
			p += sprintf((char*)p, "\\%03o", c);
		}
	}
	*p = 0;

	fputs((char*)buf, ofile);
}


int main()
{
	int cnt, total = 0;
	unsigned char *buf;

	buf = (unsigned char*) malloc(PERLINE);
	ofile = stdout;

	printf("const unsigned char %s_data[] =\n", prefix);

	for (;;) {
		cnt = fread(buf, 1, PERLINE, stdin);
		if (cnt <= 0)
			break;
		printf(" \"");
		store(cnt, buf);
		total += cnt;
		printf("\"\n");
	}

	free(buf);
	printf(";\nconst int %s_size = %d;\n", prefix, total);

	return 0;
}
