-- vim:sw=4:sts=4

-- This file is loaded at startup by libluagtk2 and contains overrides for
-- gtk functions otherwise awkward to call.  I think it is preferable to
-- write these overrides in Lua than in C to keep the C codebase small.

-- work around the strange (clever?) vararg workaround
function gtk_tree_store_append(store, parent, ...)
    local iter = gtk.new("GtkTreeIter")
    gtk.tree_store_append(store, iter, parent)
    local args = { iter }, i
    for i = 1, table.getn(arg), 1 do
	table.insert(args, i - 1)
	table.insert(args, arg[i])
    end
    table.insert(args, -1)
    store:set(unpack(args))
    return iter
end

-- avoid warning about missing argument
function gtk_tree_model_get_value(model, iter, column)
    return gtk.tree_model_get_value(model, iter, column, nil)
end

-- avoid having to allocate a GtkTreeIter
function gtk_tree_model_get_iter_from_string(model, path)
    local iter = gtk.new("GtkTreeIter")
    gtk.tree_model_get_iter_from_string(model, iter, path)
    return iter
end

-- avoid having to specify the length
function gtk_text_buffer_insert_at_cursor(buffer, text)
    gtk.text_buffer_insert_at_cursor(buffer, text, string.len(text))
end

function gtk_text_buffer_insert(buffer, iter, text)
    gtk.text_buffer_insert(buffer, iter, text, string.len(text))
end

